<?php class CCModulesData extends CodonModule {
    
    public static function loadmodulesfromcc() {
      
        $connect = 'http://www.crazycreatives.com/cc-modules';
        
        if (file_exists($_SERVER["DOCUMENT_ROOT"].'/core/cache/sem_installedmodules.cache')) {
        $contents = file($_SERVER["DOCUMENT_ROOT"].'/core/cache/sem_installedmodules.cache');
        
        $result = '';
            
        if(time() <= $contents[0]) {
				$result = $contents[1];
                $error = $contents[2];
                $errormsg = $contents[3];
			}
        }
        
        if (!$result) {
       
        $ch = curl_init();
        curl_setopt ($ch, CURLOPT_URL, $connect);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt ($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
        curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec ($ch);

            
        if(curl_errno($ch))
        {
         $error = '1';
         $errormsg = curl_error($ch);
        }
        else
        {
          $error = '0';
          $errormsg = "0";
        }
            
        curl_close($ch);
        
        $ttl = strtotime('+ 5 hours');
   
        $value = preg_replace('/\s+/', '',str_replace(PHP_EOL,null,trim($result)));
		
        $value = $ttl.PHP_EOL.$value.PHP_EOL.$error.PHP_EOL.$errormsg;
        file_put_contents($_SERVER["DOCUMENT_ROOT"].'/core/cache/sem_installedmodules.cache', $value);
            
        }
        
        self::checkexistingmodules();
        
    }
    
    public static function checkexistingmodules() {
        
        $sql = "CREATE TABLE IF NOT EXISTS cc_modules (
        id INT(6) UNSIGNED AUTO_INCREMENT PRIMARY KEY
        )";
        DB::query($sql);
        
        $sql = "SELECT * FROM cc_modules WHERE id = 1";
        $res = DB::get_row($sql);
        
        if(!$res)
        {
           $sql = "INSERT INTO cc_modules (id) VALUES (1)";
           $res = DB::query($sql);
        }
        
        if (file_exists($_SERVER["DOCUMENT_ROOT"].'/core/cache/sem_installedmodules.cache')) {
        $contents = file($_SERVER["DOCUMENT_ROOT"].'/core/cache/sem_installedmodules.cache');
        }
        else
        {
            return;
        }
        
        $modules = [];
        
        $modules = explode(',', $contents[1]);
        
        
        if($modules)
            foreach($modules as $module)
            {  
                $firstelement = 0;
                $secondelement = 0;
                $modulename = trim($module);
                
                if(strpos($module, '0') !== false)
                {
                    continue;
                }
                
                if(strpos($module, '1') !== false)
                {
                    $modulename = str_replace('1', '', $module);
                    $firstelement = 1;
                }
                
                if(strpos($module, '2') !== false)
                {
                    $modulename = str_replace('2', '', $module);
                    $secondelement = 1;
                }
                                              
                $modsplit = explode('_', $modulename);
                                              
                if($firstelement || $secondelement)
                {
                    if($firstelement){
                         $modulenameins = $modsplit[1];
                    }
                    
                    if($secondelement){
                         $modulenameins = $modsplit[2];
                    }
                }
                else
                {
                         $modulenameins = $modsplit[0];                 
                }
                
                $modulename = trim($modulename);
                
                $sql = "SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA = '".DBASE_NAME."' AND TABLE_NAME = 'cc_modules' AND COLUMN_NAME = '$modulenameins'";
                $res = DB::get_row($sql);
                
                if(!$res)
                {
                    $sql = "ALTER TABLE cc_modules ADD $modulenameins INT(6) DEFAULT 0";
                    DB::query($sql);
                }
                
                
                $sql = "SHOW TABLES LIKE '$modulename'";
                $res = DB::get_row($sql);
                

                if($res)
                {
                    $moduleexists = 1;
                }
                else
                {
                    $moduleexists = 0;
                }
                
                $sql = "UPDATE cc_modules SET $modulenameins = '$moduleexists' WHERE id = 1";
                DB::query($sql);
                
                
                
            }
        
        echo 'Modules Checked';
        return;
    }
    
    public static function getinstalledmodules()
    {
        $sql = "SELECT * FROM cc_modules WHERE id = 1";
        $res = DB::get_results($sql);
        
        if($res)
        {
            echo "<pre>";
            print_r($res);
            echo "</pre>";
        }
    }
    
    public static function getmodulestatus()
    {
        $sql = "SELECT * FROM cc_modules WHERE id = 1";
        $res = DB::get_row($sql);
        
        return($res);
    }
    
}
?>
